#include <stdio.h>
#include <stdint.h>

struct A
{
  uint32_t a;
  uint64_t b;
  uint64_t c;
} __attribute__ ((packed));

struct B
{
  uint32_t a;
  uint64_t b;
  uint64_t c;
};

struct C
{
  uint32_t a;
  uint32_t b;
  uint64_t c;
};

int main(int argc, char *argv[])
{
  struct A a = {1, 2, 3};
  struct B b = {1, 2, 3};
  struct C c = {1, 2, 3};
  uint32_t m[6] = {1, 2, 3, 4, 5, 6};
  struct A *ma = (struct A *) m;
  struct A *ma1 = (struct A *) (m + 1);

  printf("a.a @ %p = %x\n", &a.a, a.a);
  printf("a.b @ %p = %llx\n", &a.b, a.b);
  printf("a.c @ %p = %llx\n\n", &a.c, a.c);
  printf("b.a @ %p = %x\n", &b.a, b.a);
  printf("b.b @ %p = %llx\n", &b.b, b.b);
  printf("b.c @ %p = %llx\n\n", &b.c, b.c);
  printf("c.a @ %p = %x\n", &c.a, c.a);
  printf("c.b @ %p = %x\n", &c.b, c.b);
  printf("c.c @ %p = %llx\n\n", &c.c, c.c);
  printf("ma.a @ %p = %x\n", &ma->a, ma->a);
  printf("ma.b @ %p = %llx\n", &ma->b, ma->b);
  printf("ma.c @ %p = %llx\n\n", &ma->c, ma->c);
  printf("ma1.a @ %p = %x\n", &ma1->a, ma1->a);
  printf("ma1.b @ %p = %llx\n", &ma1->b, ma1->b);
  printf("ma1.c @ %p = %llx\n\n", &ma1->c, ma1->c);

  return 0;
}
